unit Unit1;

{ recursive logarithm project}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    StaticText1: TStaticText;
    goBtn: TBitBtn;
    resetBtn: TBitBtn;
    Label3: TLabel;
    StaticText2: TStaticText;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure resetBtnClick(Sender: TObject);
    procedure goBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

Const
  decimalseparator= '.';  //added for english decimal point

implementation

{$R *.dfm}

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if activecontrol = edit1 then
  if not (key in ['0'..'9',#8]) then key := #0;
 if activecontrol = edit2 then
 begin
  if not (key in ['0'..'9',#8,decimalseparator]) then key := #0;
  if key = decimalseparator then
   if pos(edit2.Text,decimalseparator) > 0 then key := #0;
 end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_RETURN then
  if activecontrol = edit1 then activecontrol := edit2
   else activecontrol := edit1;
end;

procedure TForm1.resetBtnClick(Sender: TObject);
begin
 activecontrol := edit2;
 edit1.Text := '10';
 edit2.Text := '1';
 statictext1.Caption := 'XXX';
 statictext2.Caption := 'XXX';
end;

function recLog(b,a : double) : double;
//recursive logarithm calculation
//b : base; a : number
var c : byte;
    b2,bt : double;
    GO : boolean;
begin
 c := 0;
 b2 := 1;
 repeat
  bt := b2 * b;
  GO := a >= bt;
  if GO then begin
              inc(c);
              b2 := b2 * b;
             end;
 until GO = false;
 a := a/b2;
 if a > 1.000001 then result := c + 1/reclog(a,b)
  else result := c;
end;

procedure TForm1.goBtnClick(Sender: TObject);
//calculate logarithm
//base: edit1;     number : edit2
const fs = '#0.########';
var a,b,x : double;
    OK : boolean;
begin
 activecontrol := edit2;
 a := 0; b := 0;
 if length(edit1.Text) = 0 then edit1.Text := '10';
 if length(edit2.Text) = 0 then edit2.Text := '1';
 try
  b := strtofloat(edit1.Text);
  a := strtofloat(edit2.Text);
  OK := (b > 1) and (a >= 1);
 except
  OK := false;
 end;
 if OK then
  begin
   x := RecLog(b,a);
   statictext1.Caption := formatfloat(fs,x);
   statictext2.caption := formatfloat(fs,ln(a)/ln(b));
  end else resetBtnClick(self);
end;

end.
 